#ifndef _LINUX_AUTOSLAB_H
#define _LINUX_AUTOSLAB_H

#ifdef AUTOSLAB_PLUGIN
#include <linux/compiler.h>
#include <linux/types.h>

struct autoslab_info {
	const char *name;
	const char *typename;
	unsigned int size;
	unsigned int align;
	slab_flags_t flags;
	unsigned int useroffset;
	unsigned int usersize;
};

struct autoslab_infos {
	struct autoslab_info *normal;
#ifdef CONFIG_ZONE_DMA
	struct autoslab_info *dma;
#endif
#ifdef CONFIG_ZONE_DMA32
	struct autoslab_info *dma32;
#endif
//	struct autoslab_info *reclaimable;
};

extern union autoslab_caches {
	const struct autoslab_info *info;
	struct kmem_cache *cache;
} __autoslabs_start[], __autoslabs_stop[],
  __autoslabs_init_start[], __autoslabs_init_stop[];
#endif /* AUTOSLAB_PLUGIN */

#endif
