#!/bin/sh
# SPDX-License-Identifier: GPL-2.0

set -e

srctree=$(dirname "$0")

gccplugins_dir=$($* -print-file-name=plugin)
gccversion=$($* -E -dM - < /dev/null | grep __GNUC__ | sed -ne 's/[^0-9]*//p')
if [ $gccversion -ge 11 ]; then
	std=c++11
else
	std=gnu++98
fi

# we need a c++ compiler that supports the designated initializer GNU extension
$HOSTCC -v -c -x c++ -std=$std - -fsyntax-only -I $srctree/gcc-plugins -I $gccplugins_dir/include 2>/dev/null <<EOF
#include "gcc-common.h"
class test {
public:
	int test;
} test = {
	.test = 1
};
EOF
